#ifndef __MESSAGE_H__
#define __MESSAGE_H__

#include <ctime>
#include <string>

class Message {
    public:
        enum {
            Unknown = 0,
            Text,
            HTML,
            TypesEnd
        };

        Message()
            : m_text(),
              m_created(0),
              m_received(0),
              m_showTime(0),
              m_type(TypesEnd),
              m_read(false)
        {}

        Message(const std::string & text,
                time_t created,
                time_t received,
                time_t showTime,
                unsigned type)
            : m_text(text),
              m_created(created),
              m_received(received),
              m_showTime(showTime),
              m_type(type),
              m_read(false)
        {}

        const std::string & text() const { return m_text; }
        time_t created() const { return m_created; }
        time_t received() const { return m_received; }
        time_t showTime() const { return m_showTime; }
        unsigned type() const { return m_type; }
        bool read() const { return m_read; }

        void markAsRead() { m_read = true; }

    private:
        std::string m_text;
        time_t m_created;
        time_t m_received;
        time_t m_showTime;
        unsigned m_type;
        bool m_read;
};

#endif
