#ifndef __MESSAGE_HISTORY_H__
#define __MESSAGE_HISTORY_H__

#include <vector>

#include <boost/filesystem.hpp>

#include "message.h"

typedef std::vector<Message> MessageList;

class MessageHistory {
    public:
        MessageHistory(const boost::filesystem::path & storagePath);
        ~MessageHistory();

        size_t add(const Message & message);
        size_t count() const { return m_messages.size(); }
        bool erase(size_t pos);
        bool eraseRange(size_t from, size_t count);
        const Message & get(size_t pos) const { return m_messages[pos]; }

        MessageList::const_iterator begin() const { return m_messages.begin(); }
        MessageList::const_iterator end() const { return m_messages.end(); }

        bool save();
        bool restore();

    private:
        const boost::filesystem::path m_storagePath;
        MessageList m_messages;
};

#endif
