#ifndef __PATH_PROVIDER_H__
#define __PATH_PROVIDER_H__

#include <string>
#include <vector>

#include <boost/filesystem.hpp>

class PathProvider {
    public:
        PathProvider(const std::string & appName) : m_appName(appName) {}
        virtual ~PathProvider() {}

        virtual boost::filesystem::path getHomeDir() const = 0;
        virtual boost::filesystem::path getDataDir() const = 0;
        virtual boost::filesystem::path getExecDir() const;
        boost::filesystem::path getProfileDir(const std::string & profile) const;
        boost::filesystem::path getResourcePath(const std::string & resource) const;

    protected:
        virtual std::vector<boost::filesystem::path> getResourceDirs() const = 0;
        const std::string& getAppName() const { return m_appName; }

    private:
        std::string m_appName;
};

#endif
