#include "ia_auth_c.h"
#include "ia.h"
#include "ia_factory.h"

IAFactory::IAFactory(const std::string & serverName,
                     uint16_t port,
                     const std::string & login,
                     const std::string & password,
                     bool reconnect)
    : m_serverName(serverName),
      m_port(port),
      m_login(login),
      m_password(password),
      m_reconnect(reconnect)
{
}

IA * IAFactory::newIA() const
{
    IAClientPtr pia(new IA_CLIENT_PROT(m_serverName,
                                       m_port,
                                       m_login,
                                       m_password));
    pia->setReconnect(m_reconnect);
    pia->setStatusCb(m_statusCb);
    pia->setStatCb(m_statCb);
    pia->setMessageCb(m_messageCb);
    pia->setErrorCb(m_errorCb);
    pia->setDirNamesCb(m_dirNamesCb);
    pia->start();

    return new IA(pia);
}
