#include <cstdlib>
#include <iostream>

#include <boost/algorithm/string.hpp>

#include "mac_path_provider.h"

MacPathProvider::MacPathProvider(const std::string & name)
    : PathProvider(name)
{
    resDirs.push_back(getExecDir() / "../Resources");
    resDirs.push_back(getExecDir() / ".."); // Development
}

boost::filesystem::path MacPathProvider::getDataDir() const {
    boost::filesystem::path path(getHomeDir() / "Library" / "Application Support" / boost::to_lower_copy(getAppName()));
    try {
        boost::filesystem::create_directory(path);
    }
    catch (const boost::filesystem::filesystem_error & e) {
        std::cerr << "Failed to create data dir ('" << path.string() << "'): " << e.what() << std::endl;
    }
    return path;
}

boost::filesystem::path MacPathProvider::getHomeDir() const {
    return boost::filesystem::path(getenv("HOME"));
}
