#include "win_path_provider.h"

WinPathProvider::WinPathProvider(const std::string & name)
    : PathProvider(name)
{
    resDirs.push_back(getExecDir());
    resDirs.push_back(getExecDir() / "../.."); // Development
}

boost::filesystem::path WinPathProvider::getDataDir() const
{
    char * appData = getenv("APPDATA"); // LOCALAPPDATA
    // TODO: Use SHGetFolderPath with CSIDL_APPDATA or CSIDL_LOCAL_APPDATA
    boost::filesystem::path path(boost::filesystem::path(appData) / getAppName());
    try {
        boost::filesystem::create_directory(path);
    }
    catch (const boost::filesystem::filesystem_error & e) {
        std::cerr << "Failed to create data dir ('" << path.string() << "'): " << e.what() << std::endl;
    }
    return path;
}

boost::filesystem::path WinPathProvider::getHomeDir() const
{
    char * path = getenv("USERPROFILE");
    // TODO: Use SHGetFolderPath with CSIDL_PERSONAL (My Documents)?
    return boost::filesystem::path(path);
}
