#ifndef __MESSAGES_MODEL_H__
#define __MESSAGES_MODEL_H__

#include <boost/filesystem.hpp>

#include <Qt> // DisplayRole
#include <QAbstractListModel>
#include <QModelIndex>
#include <QVariant>
#include <QString>

#include "message.h"
#include "message_history.h"

class MessagesModel : public QAbstractListModel {
    Q_OBJECT

    public:
        MessagesModel(QObject * parent, const boost::filesystem::path & dataDir);
        ~MessagesModel();

        int rowCount(const QModelIndex & parent = QModelIndex()) const;
        QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;
        QString dataDate(const QModelIndex & index) const;
        QString dataText(const QModelIndex & index) const;

        void addMessage(const Message & message);

    private:
        MessageHistory m_history;
};

#endif
